#!/usr/bin/bash

set -euo pipefail

# Chat writing to archive file
# See https://the-dam.org/docs/explanations/SecureBash.html
POSIXLY_CORRECT=1
case $SHELLOPTS in
    *privileged*)   ;;
    *)  \exec /usr/bin/bash -p "$0" "$@" ;;
esac
\unset -f command builtin unset shopt set unalias
\unset -f read true : exit echo printf
\unalias -a
\shopt -u expand_aliases
set +o posix

USER_FG_COLOR=$(( 16#$(\echo "$2" | /usr/bin/md5sum | /usr/bin/head -c2) ))  # Arbitrary number in [0:255]
USER_BG_COLOR=$(( ("$USER_FG_COLOR" + 128) % 255 ))  # Most of the time, high enough contrast

while IFS= read -s -r line;
    do
    printf '\e[38;5;243m%(%H:%M)T \e[38;5;%dm\e[48;5;%dm%-9s\e[0m %s\e[0m\n' \
        -1 "$USER_FG_COLOR" "$USER_BG_COLOR" "$2" "$line" | openssl enc -aes128 -pbkdf2 -A -a -e -k $3 | tee -a ./chat/$1.out >> ./chat/$1;
    echo "" >> ./chat/$1;
    echo "" >> ./chat/$1.out;
    done
